databaseChangeLog:
  - changeSet:
      id: create-table-user
      author: dev
      changes:
        - createTable:
            tableName: user
            columns:
              - column:
                  autoIncrement: true
                  constraints:
                    nullable: false
                    primaryKey: true
                    primaryKeyName: user_pk
                  name: id
                  type: bigserial
              - column:
                  constraints:
                    nullable: false
                  name: username
                  type: varchar(200)
              - column:
                  constraints:
                    nullable: false
                  name: email
                  type: varchar(500)
              - column:
                  constraints:
                    nullable: false
                  name: password
                  type: varchar(200)
              - column:
                  name: bio
                  type: text
              - column:
                  name: image
                  type: varchar(200)
  - changeSet:
      id: create-table-article
      author: dev
      changes:
        - createTable:
            tableName: article
            columns:
              - column:
                  autoIncrement: true
                  constraints:
                    nullable: false
                    primaryKey: true
                    primaryKeyName: article_pk
                  name: id
                  type: bigserial
              - column:
                  constraints:
                    nullable: false
                  name: slug
                  type: varchar(200)
              - column:
                  constraints:
                    nullable: false
                  name: title
                  type: varchar(200)
              - column:
                  constraints:
                    nullable: false
                  name: description
                  type: text
              - column:
                  constraints:
                    nullable: false
                  name: body
                  type: text
              - column:
                  constraints:
                    nullable: false
                  name: created_at
                  type: timestamp(3)
              - column:
                  constraints:
                    nullable: false
                  name: updated_at
                  type: timestamp(3)
              - column:
                  constraints:
                    nullable: false
                  name: author_id
                  type: bigint
        - addForeignKeyConstraint:
            baseColumnNames: author_id
            baseTableName: article
            constraintName: article_fk_author_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: user
  - changeSet:
      id: create-table-tag
      author: dev
      changes:
        - createTable:
            tableName: tag
            columns:
              - column:
                  autoIncrement: true
                  constraints:
                    nullable: false
                    primaryKey: true
                    primaryKeyName: tag_pk
                  name: id
                  type: bigserial
              - column:
                  constraints:
                    nullable: false
                  name: name
                  type: text
  - changeSet:
      id: create-table-article_tag
      author: dev
      changes:
        - createTable:
            tableName: article_tag
            columns:
              - column:
                  constraints:
                    nullable: false
                  name: article_id
                  type: bigint
              - column:
                  constraints:
                    nullable: false
                  name: tag_id
                  type: bigint
        - addPrimaryKey:
            columnNames: article_id, tag_id
            constraintName: article_tag_pk
            tableName: article_tag
        - addForeignKeyConstraint:
            baseColumnNames: article_id
            baseTableName: article_tag
            constraintName: article_tag_fk_article_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: article
        - addForeignKeyConstraint:
            baseColumnNames: tag_id
            baseTableName: article_tag
            constraintName: article_tag_fk_tag_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: tag
  - changeSet:
      id: create-table-comment
      author: dev
      changes:
        - createTable:
            tableName: comment
            columns:
              - column:
                  autoIncrement: true
                  constraints:
                    nullable: false
                    primaryKey: true
                    primaryKeyName: comment_pk
                  name: id
                  type: bigserial
              - column:
                  constraints:
                    nullable: false
                  name: body
                  type: text
              - column:
                  constraints:
                    nullable: false
                  name: created_at
                  type: timestamp(3)
              - column:
                  constraints:
                    nullable: false
                  name: updated_at
                  type: timestamp(3)
              - column:
                  constraints:
                    nullable: false
                  name: author_id
                  type: bigint
              - column:
                  constraints:
                    nullable: false
                  name: article_id
                  type: bigint
        - addForeignKeyConstraint:
            baseColumnNames: author_id
            baseTableName: comment
            constraintName: comment_fk_author_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: user
        - addForeignKeyConstraint:
            baseColumnNames: article_id
            baseTableName: comment
            constraintName: comment_fk_article_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: article
  - changeSet:
      id: create-table-favorite
      author: dev
      changes:
        - createTable:
            tableName: favorite
            columns:
              - column:
                  constraints:
                    nullable: false
                  name: user_id
                  type: bigint
              - column:
                  constraints:
                    nullable: false
                  name: article_id
                  type: bigint
        - addPrimaryKey:
            columnNames: user_id, article_id
            constraintName: favorite_pk
            tableName: favorite
        - addForeignKeyConstraint:
            baseColumnNames: user_id
            baseTableName: favorite
            constraintName: favorite_fk_user_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: user
        - addForeignKeyConstraint:
            baseColumnNames: article_id
            baseTableName: favorite
            constraintName: favorite_fk_article_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: article
  - changeSet:
      id: create-table-follow
      author: dev
      changes:
        - createTable:
            tableName: follow
            columns:
              - column:
                  constraints:
                    nullable: false
                  name: followee_id
                  type: bigint
              - column:
                  constraints:
                    nullable: false
                  name: follower_id
                  type: bigint
        - addPrimaryKey:
            columnNames: followee_id, follower_id
            constraintName: follow_pk
            tableName: follow
        - addForeignKeyConstraint:
            baseColumnNames: followee_id
            baseTableName: follow
            constraintName: follow_fk_followee_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: user
        - addForeignKeyConstraint:
            baseColumnNames: follower_id
            baseTableName: follow
            constraintName: follow_fk_follower_id
            deferrable: false
            initiallyDeferred: false
            onDelete: CASCADE
            onUpdate: CASCADE
            referencedColumnNames: id
            referencedTableName: user
